/*
	COMPSCI375 Assingment02 (CourseWork 2.2)
	Author: Lily Chia-Chin HSIEH
	UPI: lhsi003
	ID number: 3440845
*/

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import java.io.*;
import javax.imageio.*;

/*
	This class shows the histogram of each of the RGB values of an image
	and also shows the coordinates, intensity, mean and variance of the 11*11 window
	of where the cursor is located on the image
*/
public class Ass02 extends JFrame implements MouseMotionListener {

	// threshold1 is close to the mean in relation to the current image
	// threshold2 is close to the lower end (close to 0)
	// threshold3 is close to the higher end (closee to 255)
	public int threshold1 = 220, threshold2 = 100, threshold3 = 245;
	private Image image, imageThresh, imageComp;
	private int xPos, yPos;
	private int imageW = 450, imageH = 337;
	private int[] imagePixels;
	private int[] imageR = new int[256];
	private int[] imageG = new int[256];
	private int[] imageB = new int[256];
    private int rMax = 0, gMax = 0, bMax = 0;
    private ColorModel model;
    private int histW = 257, histH = 120;
    PixelGrabber pg;
    private int[] thresh1;
    private DrawFrame df1, df2, df3;



	/*
		This method initializes the window
		Loads the image and sets the layout
		Initializes the histogram and each of the 3 DrawFrame objects
	*/
	public Ass02() {
		Container cont = getContentPane();
		cont.setLayout(null);
		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		setResizable(false);
        setTitle("Assg02 Original Image with histogram");
		pack();
		try{
			image = ImageIO.read(new File("15.bmp"));  // image loading
			MediaTracker tracker = new MediaTracker(this);
			tracker.addImage(image, 0);
			tracker.waitForID(0);
			cont.addMouseMotionListener(this);
		} catch(Exception e) {
			System.out.println(e.getMessage());
			System.exit(0);
		}
		histInfo();

		setSize(imageW+histW+100, imageH+50);
		thresh1 = new int[imageW * imageH];
		threshold(threshold1);
		df1 = new DrawFrame(imageThresh);
		df1.setVisible(true);
		threshold(threshold2);
		df2 = new DrawFrame(imageThresh);
		df2.setVisible(true);
		threshold(threshold3);
		df3 = new DrawFrame(imageThresh);
		df3.setVisible(true);
	}

	/*
		This method gets all the information needed to draw the histogram of the image
	*/
	public void histInfo() {
		imageW = image.getWidth(this);
        imageH = image.getHeight(this);
        imagePixels = new int[imageW*imageH];

        PixelGrabber imagepg = new PixelGrabber(image, 0, 0, imageW, imageH, imagePixels, 0, imageW);
        try {
            imagepg.grabPixels();
        } catch(InterruptedException e) {}

        model = ColorModel.getRGBdefault();

        // for loop for getting the RGB values of the whole image
        for(int i = 0; i < imageW; i++) {
            for(int j = 0; j < imageH; j++) {
                imageR[model.getRed(imagePixels[j * imageW + i])]++;
            }
        }

		// for loop for getting the maximum value of frequency for each of the RGB values
		// for later use when drawing the histogram
        for(int i = 0; i < imageR.length; i++){
            if(rMax < imageR[i])
                rMax = imageR[i];
        }
	}

	/*
		This method does the painting of the image, 11*11 window and the histograms
	*/
	public void paint(Graphics g) {
		g.drawImage(image, 15, 30, this);		// paints the image

		// paints the histogram
		{
            g.setColor(Color.ORANGE);
            int yEnd;
            // calculates the correct ratio of frequencies and resize it to a suitable ratio
            // for the histogram frame size
            for(int i = 0; i < imageR.length; i++) {
                if(imageR[i] != 0) {
                    yEnd = (int)(((double)imageR[i] / (double)rMax) * (histH-1));
                    g.drawLine(imageW+51+i, imageH/2+histH-1, imageW+51+i, (imageH/2+histH)-yEnd);
                }
            }
			g.setColor(Color.BLACK);
            g.drawRect(imageW+50, imageH/2, histW, histH);
		}
	}

	/*
		This method gets called everytime when the mouse moves
		It gets the position of the cursor and also the RGB values
	*/
	public void mouseMoved(MouseEvent e) {
		repaint();
	}

	/*
		This method gets called everytime when the mouse is dragged
		It does not do anything at this point since nothing is required at this stage
	*/
	public void mouseDragged(MouseEvent e) {}

	/*
		This method transforms the image to a binary picture
		in respect to the threshold passed in
		and sets each pixel to either 0 or Gmax (ie, black or white)
	*/
	public void threshold(int th) {
		int threshTemp = th;
		for(int i = 0; i < imagePixels.length; i++) {
			if((imagePixels[i] & 0xff) < threshTemp)
				thresh1[i] = 0xff000000;
			else
				thresh1[i] = 0xffffffff;
		}
		imageThresh = createImage(new MemoryImageSource(imageW, imageH, thresh1, 0, imageW));// offset=0
	}

	/*
		This is the main method
	*/
	public static void main(String[] args) {
		Ass02 a02 = new Ass02();
		a02.setVisible(true);
	}

}